﻿--[[ Postal_BlackBook: Adds a popup contact list when you mouseover the To: field. ]]--

assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local dewdrop = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Postal")

--based on a free function at wowwiki
local function tremovebyval(tab, val)
	for k,v in pairs(tab) do
		if v == val then
			table.remove(tab, k)
			return true
		end
	end
	return false
end


----------------------------------
--      Module Declaration      --
----------------------------------

Postal_BlackBook = Postal:NewModule("BlackBook")
Postal_BlackBook.defaults = {
	contacts ={}
}

Postal_BlackBook.revision = tonumber(string.sub("$Revision: 25567 $", 12, -3))

function Postal_BlackBook:OnEnable()
	dewdrop:Register(
		SendMailNameEditBox,
		'children', function(level, value) Postal_BlackBook:Populate(level, value) end,
		'point', function(parent) return "TOPLEFT", "BOTTOMLEFT" end,
		'dontHook', true
	)
	self:RegisterEvent("MAIL_CLOSED")
	self:HookScript(SendMailNameEditBox, "OnEnter", function()  dewdrop:Open(SendMailNameEditBox) end)
end

function Postal_BlackBook:MAIL_CLOSED()
	dewdrop:Close()
end

function Postal_BlackBook:Populate(level, value)
	if level == 1 then
		local contact
		dewdrop:AddLine('text', L["Contacts"], 'isTitle', true)
		for i, contact in pairs(self.db.char.contacts) do
			dewdrop:AddLine('text', contact, 'func', function() SendMailNameEditBox:SetText(contact) end )
		end
		dewdrop:AddLine('text', "")
		dewdrop:AddLine(
			'text', L["Add Contact"],
			'func',
			function()
				if SendMailNameEditBox:GetText() == "" then return end
				if self.db.char.contacts[20] then tremove(self.db.char.contacts, 20) end
					table.insert(self.db.char.contacts, SendMailNameEditBox:GetText())
					table.sort(self.db.char.contacts)
			end
		)
		dewdrop:AddLine(
			'text', L["Remove Contact"],
			'func',
			function()
				if SendMailNameEditBox:GetText() == "" then return end
				tremovebyval(self.db.char.contacts, SendMailNameEditBox:GetText())
			end
		)
		dewdrop:AddLine('text', "")
		dewdrop:AddLine( 'text', L["Friends"], 'hasArrow', true, 'value', "friend" )
		-- dewdrop:AddLine('text', "Guild", 'hasArrow', true, 'value', "guild" )
	elseif level == 2 then
		local numFriends, name
		if value == "friend" then
			numFriends = GetNumFriends()
			if ( numFriends > 0 ) then
				for i=1, numFriends do
					name = GetFriendInfo(i)
					dewdrop:AddLine(
						'text', name,
						'func', function(name) SendMailNameEditBox:SetText(name) end,
						'arg1', name
					)
				end
			end
		elseif value == "guild" then
			numFriends = GetNumGuildMembers(true)
			if ( numFriends > 0 ) then
				for i=1, numFriends do
					name = GetGuildRosterInfo(i)
					dewdrop:AddLine(
						'text', name,
						'func', SendMailNameEditBox:SetText(name)
					)
				end
			end
		end
	end
end

