﻿--[[ Postal Express: Mouse Shortcuts for Mail ]]--
--shift-click to take item/money from mail
--ctrl-click to return mail
--alt-click to add item to SendMailFrame

assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local lib = AceLibrary("PostalLib-1.0")
local L = AceLibrary("AceLocale-2.2"):new("Postal")

----------------------------------
--      Module Declaration      --
----------------------------------

Postal_Express = Postal:NewModule("Express")
Postal_Express.revision = tonumber(string.sub("$Revision: 25567 $", 12, -3))

function Postal_Express:OnEnable()
 self:Hook("InboxFrame_OnClick", true)
 self:SecureHook(GameTooltip, "SetInboxItem")
 self:Hook("ContainerFrameItemButton_OnModifiedClick", true)
end

-- Ctrl-Click and Shift-Clicks Shortcuts for Mail, based on ExpressMail by Tekkub
function Postal_Express:SetInboxItem(tooltip, index)
	local money, COD, _, hasItem, _, wasReturned, _, canReply = select(5, GetInboxHeaderInfo(index))
	if money > 0 or COD > 0 or hasItem then
		tooltip:AddLine(L["Shift - Take Item"])
	end
	if not wasReturned and canReply then
		tooltip:AddLine(L["Ctrl - Return Item"])
	end
end

function Postal_Express:InboxFrame_OnClick(index)
	if IsShiftKeyDown() then
		lib:PurgeMail(index, 1)
	elseif IsControlKeyDown() then 
		lib:ReturnMail(index)
	else
		self.hooks["InboxFrame_OnClick"](index)
	end
end

function Postal_Express:ContainerFrameItemButton_OnModifiedClick(...)
	if select(1, ...) == "LeftButton" and IsAltKeyDown() and SendMailFrame:IsVisible() and not CursorHasItem() then
		local bag, slot = this:GetParent():GetID(), this:GetID()
		local texture, count = GetContainerItemInfo(bag, slot)
		PickupContainerItem(bag, slot)
		ClickSendMailItemButton()
		local smf_texture, smf_count = select(2, GetSendMailItem())
		if SendMailNameEditBox:GetText() and texture == smf_texture and count == smf_count then
			SendMailFrame_SendMail()
		end
		return
	end
	self.hooks["ContainerFrameItemButton_OnModifiedClick"](...)
end
